<template>
  <table
    role="table"
    :aria-labelledby="`Tableau d'administration des données ${clientName}`"
  >
    <thead
      role="rowgroup"
    >
      <tr>
        <th
          v-if="selectable"
          class="check-cell"
          scope="col"
          style="width: 3%;"
        >
          <div class="form-check">
            <input
              class="form-check-input-table"
              style="margin-left: -1.35em;"
              type="checkbox"
              v-model="columnCheckbox"
              @click.stop="selectAllRows"
            >
          </div>
        </th>
        <th
          v-for="field of fields"
          :key="field.key"
          role="columnheader"
          scope="col"
          :style="{ width: field.width }"
        >
          <div
            class="cell-header"
            :style="{
              'justify-content': field.centered ? 'center' : '',
              'pointer-events': field.sortable ? '' : 'none'
            }"
            @click="sortField(field.apiName)"
          >
            {{ field.key }}
            <div
              v-if="field.sortable"
              class="sort-field"
            >
              <b-icon-caret-up-fill
                :class="{
                  active: sortedUp && sortedField === field.apiName,
                  disabled: sortedDown && sortedField === field.apiName
                }"
              />
              <b-icon-caret-down-fill
                :class="{
                  active: sortedDown && sortedField === field.apiName,
                  disabled: sortedUp && sortedField === field.apiName
                }"
              />
            </div>
          </div>
        </th>
      </tr>
    </thead>
    <tbody role="rowgroup">
      <tr
        v-if="items.length === 0"
      >
        <div style="margin: 0.5em; font-style: italic;">Aucun élément à afficher</div>
      </tr>
      <TableRow
        ref="tableRowComponent"
        v-for="item in items"
        :key="item.id"
        :routeTo="routeTo"
        :item="item"
        :selectable="selectable"
        :selected="columnCheckbox"
        :allowDeletion="allowDeletion"
        :allowDuplication="allowDuplication"
        v-on="$listeners"
      />
    </tbody>
  </table>
</template>

<script>
import TableRow from '@/components/TableRow.vue';

import { mapState } from 'vuex';

export default {
  name: 'CustomTable',

  components: {
    TableRow
  },

  props: {
    routeTo: {
      type: String,
      default: null
    },
    fields: {
      type: Array,
      default: () => { return [] }
    },
    items: {
      type: Array,
      default: () => { return [] }
    },
    defaultSorting: {
      type: Object,
       default: () => { return {
         sortedUp: null,
         sortedDown: null,
         sortedField: null
       } }
    },
    sortFunction: {
      type: Function,
      default: () => { return {} }
    },
    selectable: {
      type: Boolean,
      default: false
    },
    allowDeletion: {
      type: Boolean,
      default: true
    },
    allowDuplication: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      columnCheckbox: false,
      sortedUp: false,
      sortedDown: false,
      sortedField: null
    }
  },

  computed: {
    ...mapState('pagination', ['currentPage']),

    clientName() {
      return process.env.VUE_APP_CLIENT_NAME;
    }
  },

  watch: {
    sortedField: function(newValue) {
      this.$emit('sorted', {
        direction: this.sortedUp ? '-' : '',
        field: newValue
      });
    }
  },

  created() {
    if (this.defaultSorting.sortedField) {
      this.sortedUp = this.defaultSorting.sortedUp;
      this.sortedDown = this.defaultSorting.sortedDown;
      this.sortedField = this.defaultSorting.sortedField;
    }
  },

  methods: {
    selectAllRows() {
      this.columnCheckbox = !this.columnCheckbox;
      this.$emit('select-all', this.columnCheckbox);
      if (this.$refs.tableRowComponent) {
        for (const row of this.$refs.tableRowComponent) {
          row.selectRow(this.columnCheckbox);
        }
      }
    },

    sortField(field) {

      if (field !== this.sortedField) {
        this.sortedDown = false;
        this.sortedUp = false;
      }

      if (!this.sortedUp && !this.sortedDown) {

        this.$emit('loading', true);
        this.sortFunction({
          direction: '',
          field: field,
          page: this.currentPage
        }).then(() => {
          this.sortedDown = false;
          this.sortedUp = true;
          this.sortedField = field;
          this.$emit('loading', false);
        });

      } else if (this.sortedUp && !this.sortedDown) {

        this.$emit('loading', true);
        this.sortFunction({
          direction: '-',
          field: field,
          page: this.currentPage
        }).then(() => {
          this.sortedDown = true;
          this.sortedUp = false;
          this.sortedField = field;
          this.$emit('loading', false);
        });

      } else if (!this.sortedUp && this.sortedDown) {
        
        this.$emit('loading', true);
        this.sortFunction({
          direction: '',
          field: field,
          page: this.currentPage
        }).then(() => {
          this.sortedDown = false;
          this.sortedUp = true;
          this.sortedField = field;
          this.$emit('loading', false);
        });

      }

    }
  }
}
</script>
